"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ensure = exports.deepCloneNullPrototype = exports.UNSAFE_KEYS = void 0;
exports.UNSAFE_KEYS = new Set([
    '__proto__',
    'constructor',
    'prototype',
    'hasOwnProperty',
]);
function deepCloneNullPrototype(obj) {
    if (Array.isArray(obj)) {
        return obj.map(deepCloneNullPrototype);
    }
    if (obj === null || typeof obj !== 'object') {
        return obj;
    }
    const clone = Object.create(null);
    for (const key in obj) {
        if (exports.UNSAFE_KEYS.has(key)) {
            continue;
        }
        clone[key] = deepCloneNullPrototype(obj[key]);
    }
    return clone;
}
exports.deepCloneNullPrototype = deepCloneNullPrototype;
function ensure(condition, message) {
    if (!condition) {
        throw new Error(message);
    }
}
exports.ensure = ensure;
